package io.emqx.exhook.MongoDB;

import com.alibaba.fastjson.parser.DefaultJSONParser;
import com.alibaba.fastjson.parser.deserializer.ObjectDeserializer;
import java.lang.reflect.Type;

/*
 * 处理反序列化是numberlong的问题，对象的字段上添加即可
 * @JSONField(deserializeUsing =MongoLongConverter.class )
 */
public class MongoLongConverter implements ObjectDeserializer {

    @Override
    public Long deserialze(DefaultJSONParser parser, Type type, Object fieldName) {
        String longStr = parser.parseObject().getString("$numberLong");
        if (longStr!=null && !longStr.isEmpty()){
            return Long.parseLong(longStr);
        }
        return 0L;
    }

    @Override
    public int getFastMatchToken() {
        return 0;
    }
}